## ubertooth 2015.09.R2

=== firmware/Makefile ===
#-*- makefile -*-
#
# Copyright 2010 Michael Ossmann
#
# This file is part of Project Ubertooth.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

DIRS = blinky bluetooth_rxtx cc2400_test clock_test usb_test assembly_test

all: $(DIRS)

clean: $(DIRS:%=%_clean)

ctags: $(DIRS:%=%_ctags)

ctags_clean: $(DIRS:%=%_ctags_clean)

$(DIRS):
	$(MAKE) -C $@

$(DIRS:%=%_clean):
	$(MAKE) -C $(@:%_clean=%) clean

$(DIRS:%=%_ctags):
	@$(MAKE) --no-print-directory -C $(@:%_ctags=%) ctags

$(DIRS:%=%_ctags_clean):
	@$(MAKE) -C $(@:%_ctags_clean=%) ctags_clean

.PHONY : clean all $(DIRS)

=== host/CMakeLists.txt ===
#
# Copyright 2013 Dominic Spill
#
# This file is part of Ubertooth.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#
#top level cmake project for ubertooth lib + tools

cmake_minimum_required(VERSION 2.8)
set(MAJOR_VERSION 0)
set(MINOR_VERSION 2)
project(ubertooth_all)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

set(INSTALL_DEFAULT_BINDIR "bin" CACHE STRING "Appended to CMAKE_INSTALL_PREFIX")

set( VERSION ${MAJOR_VERSION}.${MINOR_VERSION} )
add_definitions( -DVERSION="${VERSION}" )

# Comment the following out for releases.
set(CMAKE_C_FLAGS "$ENV{CFLAGS}")

add_subdirectory(libubertooth)
add_subdirectory(ubertooth-tools)
add_subdirectory(misc)
if(NOT DISABLE_PYTHON)
	add_subdirectory(python)
endif()

# Create uninstall target
configure_file(
	${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
	${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

=== firmware/assembly_test/Makefile ===
# Hey Emacs, this is a -*- makefile -*-

# Target file name (without extension).
TARGET = assembly_test

# List C source files here. (C dependencies are automatically generated.)
SRC = $(TARGET).c \
	$(LIBS_PATH)/usb_serial.c \
	$(LIBS_PATH)/serial_fifo.c \
	$(LIBS_PATH)/LPC17xx_Startup.c \
	$(LIBS_PATH)/LPC17xx_Interrupts.c \
	$(LIBS_PATH)/ubertooth.c \
	$(LPCUSB_PATH)/usbcontrol.c \
	$(LPCUSB_PATH)/usbinit.c \
	$(LPCUSB_PATH)/usbhw_lpc.c \
	$(LPCUSB_PATH)/usbstdreq.c

# The assembly_test firmware should be installed via ISP or JTAG without a
# bootloader present.  After the test succeeds, install the bootloader with ISP
# or JTAG.
LINKER_SCRIPT = LPC17xx_Linker_Script_without_bootloader.ld

include ../common.mk

=== firmware/bluetooth_rxtx/Makefile ===
# Hey Emacs, this is a -*- makefile -*-

# Target file name (without extension).
TARGET = bluetooth_rxtx

# List C source files here. (C dependencies are automatically generated.)
SRC = $(TARGET).c \
	bluetooth.c \
	bluetooth_le.c \
	ubertooth_usb.c \
	cc2400_rangetest.c \
	ego.c \
	$(LIBS_PATH)/usb_serial.c \
	$(LIBS_PATH)/serial_fifo.c \
	$(LIBS_PATH)/LPC17xx_Startup.c \
	$(LIBS_PATH)/LPC17xx_Interrupts.c \
	$(LIBS_PATH)/ubertooth.c \
	$(LPCUSB_PATH)/usbcontrol.c \
	$(LPCUSB_PATH)/usbinit.c \
	$(LPCUSB_PATH)/usbhw_lpc.c \
	$(LPCUSB_PATH)/usbstdreq.c

include ../common.mk

=== firmware/bootloader/Makefile ===
# Hey Emacs, this is a -*- makefile -*-
#----------------------------------------------------------------------------
# WinAVR Makefile Template written by Eric B. Weddington, Jörg Wunsch, et al.
#  >> Modified for use with the LUFA project. <<
#
# Released to the Public Domain
#
# Altered for ARM Cortex-M3 by Opendous Inc. - 2010-01-05
# Altered for Project Ubertooth by Michael Ossmann 2010
#
# Additional material for this makefile was written by:
# Peter Fleury
# Tim Henigan
# Colin O'Flynn
# Reiner Patommel
# Markus Pfaff
# Sander Pool
# Frederik Rouleau
# Carlos Lamas
# Dean Camera
# Denver Gingerich
# Opendous Inc.
# Michael Ossmann
# Jared Boone
#
#----------------------------------------------------------------------------
# On command line:
#
# make all = Make software.
#
# make clean = Clean out built project files.
#
# make program = Download the hex file to the device
#
# make doxygen = Generate DoxyGen documentation for the project (must have
#                DoxyGen installed)
#
# make filename.s = Just compile filename.c into the assembler code only.
#
# make filename.i = Create a preprocessed source file for use in submitting
#                   bug reports to the GCC project.
#
# To rebuild project do "make clean" then "make all".
#----------------------------------------------------------------------------

# set to UBERTOOTH_ZERO or UBERTOOTH_ONE
BOARD  ?= UBERTOOTH_ONE

# CPU architecture
CPU = cortex-m3

# Instruction Set to use (also known as CPU Mode)
CPU_MODE = mthumb

# Additional CPU flags
CPU_FLAGS = -mapcs-frame
CPU_FLAGS_ASM = -mthumb-interwork

# Target definition for lpcusb library
LPCUSB_TARGET = LPC17xx

# Output format. (can be srec, ihex, binary)
FORMAT = ihex

# Output Directory
OUTDIR = .

# Target file name (without extension).
TARGET = bootloader

# Library paths
LIBS_PATH = ../common
LPCUSB_PATH = $(LIBS_PATH)/lpcusb/target

# List C source files here. (C dependencies are automatically generated.)
SRC = $(LIBS_PATH)/LPC17xx_Startup.c \
      $(LIBS_PATH)/LPC17xx_Interrupts.c \
      $(LIBS_PATH)/ubertooth.c \
      $(LPCUSB_PATH)/usbcontrol.c \
      $(LPCUSB_PATH)/usbinit.c \
      $(LPCUSB_PATH)/usbhw_lpc.c \
      $(LPCUSB_PATH)/usbstdreq.c

# List C++ source files here. (C dependencies are automatically generated.)
CPPSRC = $(TARGET).cpp \
         dfu.cpp \
         iap.cpp

# List Assembler source files here.
#     Make them always end in a capital .S.  Files ending in a lowercase .s
#     will not be considered source files but generated files (assembler
#     output from the compiler), and will be deleted upon "make clean"!
#     Even though the DOS/Win* filesystem matches both .s and .S the same,
#     it will preserve the spelling of the filenames, and gcc itself does
#     care about how the name is spelled on its command-line.
ASRC = 

# Object files directory
#     To put object files in current directory, use a dot (.), do NOT make
#     this an empty or blank macro!
OBJDIR = .

# Optimization level, can be [0, 1, 2, 3, s]. 
#     0 = turn off optimization. s = optimize for size.
#     (Note: 3 is not always the best optimization level. See libc FAQ.)
OPT = 0

# Debugging format.
DEBUG = dwarf-2 -g3

# Linker Script for the current MCU
LINKER_SCRIPT = LPC17xx_Linker_Script_bootloader.ld

# List any extra directories to look for include files here.
#     Each directory must be seperated by a space.
#     Use forward slashes for directory separators.
#     For a directory that has spaces, enclose it in quotes.
EXTRAINCDIRS = $(LIBS_PATH) $(LPCUSB_PATH) ../../host/libubertooth/src

# Compiler flag to set the C Standard level.
#     c89   = "ANSI" C
#     gnu89 = c89 plus GCC extensions
#     c99   = ISO C99 standard (not yet fully implemented)
#     gnu99 = c99 plus GCC extensions
CSTANDARD = -std=gnu99

# Place -D or -U options here for C sources
CDEFS  = -D$(BOARD) -D$(LPCUSB_TARGET) $(COMPILE_OPTS)

# Place -D or -U options here for ASM sources
ADEFS = 

# Place -D or -U options here for C++ sources
CPPDEFS = -D$(BOARD) -D$(LPCUSB_TARGET) $(COMPILE_OPTS)

#---------------- Compiler Options C ----------------
#  -g*:          generate debugging information
#  -O*:          optimization level
#  -f...:        tuning, see GCC manual
#  -Wall...:     warning level
#  -Wa,...:      tell GCC to pass this to the assembler.
#    -alhms...: create assembler listing
CFLAGS = -g$(DEBUG)
CFLAGS += $(CDEFS)
CFLAGS += -O$(OPT)
CFLAGS += -Wall
CFLAGS += -Wno-unused
CFLAGS += -Wno-comments
CFLAGS += -fmessage-length=0
CFLAGS += -fno-builtin
CFLAGS += -ffunction-sections
CFLAGS += -Wextra
CFLAGS += -D__thumb2__=1 
CFLAGS += -msoft-float 
CFLAGS += -mno-sched-prolog 
CFLAGS += -fno-hosted 
CFLAGS += -mtune=cortex-m3 
CFLAGS += -march=armv7-m 
CFLAGS += -mfix-cortex-m3-ldrd  
#CFLAGS += -Wundef
#CFLAGS += -funsigned-char
#CFLAGS += -funsigned-bitfields
#CFLAGS += -fno-inline-small-functions
#CFLAGS += -fpack-struct
#CFLAGS += -fshort-enums
#CFLAGS += -Wstrict-prototypes
#CFLAGS += -fno-unit-at-a-time
#CFLAGS += -Wunreachable-code
#CFLAGS += -Wsign-compare
CFLAGS += -Wa,-alhms=$(<:%.c=$(OBJDIR)/%.lst)
CFLAGS += $(patsubst %,-I%,$(EXTRAINCDIRS))
CFLAGS += $(CSTANDARD)

#---------------- Compiler Options C++ ----------------
#  -g*:          generate debugging information
#  -O*:          optimization level
#  -f...:        tuning, see GCC manual
#  -Wall...:     warning level
#  -Wa,...:      tell GCC to pass this to the assembler.
#    -alhms...: create assembler listing
CPPFLAGS = -g$(DEBUG)
CPPFLAGS += $(CPPDEFS)
CPPFLAGS += -O$(OPT)
#CPPFLAGS += -funsigned-char
#CPPFLAGS += -funsigned-bitfields
#CPPFLAGS += -fpack-struct
#CPPFLAGS += -fshort-enums
CPPFLAGS += -fno-exceptions
CPPFLAGS += -fno-rtti
CPPFLAGS += -fno-threadsafe-statics
CPPFLAGS += -Wall
CPPFLAGS += -Wextra
CPPFLAGS += -Weffc++
#CFLAGS += -Wundef
#CPPFLAGS += -mshort-calls
#CPPFLAGS += -fno-unit-at-a-time
#CPPFLAGS += -Wstrict-prototypes
#CPPFLAGS += -Wunreachable-code
#CPPFLAGS += -Wsign-compare
CPPFLAGS += -Wa,-alhms=$(<:%.cpp=$(OBJDIR)/%.lst)
CPPFLAGS += $(patsubst %,-I%,$(EXTRAINCDIRS))
#CPPFLAGS += $(CSTANDARD)

#---------------- Assembler Options ----------------
#  -Wa,...:   tell GCC to pass this to the assembler.
#  -alhms:   create listing
#  -gstabs:   have the assembler create line number information
#  -listing-cont-lines: Sets the maximum number of continuation lines of hex 
#       dump that will be displayed for a given single line of source input.
ASFLAGS = -g$(DEBUG) $(ADEFS) -I.  -alhms=$(<:%.S=$(OBJDIR)/%.lst)

#---------------- Library Options ----------------

# List any extra directories to look for libraries here.
#     Each directory must be seperated by a space.
#     Use forward slashes for directory separators.
#     For a directory that has spaces, enclose it in quotes.
EXTRALIBDIRS = $(LIBS_PATH)

#---------------- Linker Options ----------------
#  -Wl,...:     tell GCC to pass this to linker.
#    -Map:      create map file
#    --cref:    add cross reference to  map file
LDFLAGS = -Wl,-Map=$(TARGET).map
#LDFLAGS += -Wl,--relax 
#LDFLAGS += --gc-sections
LDFLAGS += $(patsubst %,-L%,$(EXTRALIBDIRS))
LDFLAGS += -static
LDFLAGS += -Wl,--start-group 
#LDFLAGS += -L$(THUMB2GNULIB) -L$(THUMB2GNULIB2)
LDFLAGS += -lc -lg -lstdc++ -lsupc++ 
LDFLAGS += -lgcc -lm 
LDFLAGS += -Wl,--end-group 

#---------------- Programming Options ----------------
LPCISP  ?= $(shell which lpc21isp)
PROGDEV ?= /dev/ttyUSB0

#============================================================================

# Define programs and commands.
CROSS_COMPILE ?= arm-none-eabi-
CC = $(CROSS_COMPILE)gcc
LD = $(CROSS_COMPILE)gcc -T
AS = $(CROSS_COMPILE)as
OBJCOPY = $(CROSS_COMPILE)objcopy
OBJDUMP = $(CROSS_COMPILE)objdump
READELF  = $(CROSS_COMPILE)readelf
SIZE = $(CROSS_COMPILE)size
AR = $(CROSS_COMPILE)ar -r
NM = $(CROSS_COMPILE)nm
REMOVE = rm -f

# Define Messages
# English
MSG_BEGIN = -------- begin --------
MSG_END = --------  end  --------
MSG_SIZE_BEFORE = Size before: 
MSG_SIZE_AFTER = Size after:
MSG_FLASH = Creating load file for Flash:
MSG_EEPROM = Creating load file for EEPROM:
MSG_EXTENDED_LISTING = Creating Extended Listing:
MSG_SYMBOL_TABLE = Creating Symbol Table:
MSG_LINKING = Linking:
MSG_COMPILING = Compiling C:
MSG_COMPILING_CPP = Compiling C++:
MSG_ASSEMBLING = Assembling:
MSG_CLEANING = Cleaning project:
MSG_CREATING_LIBRARY = Creating library:

# Define all object files.
OBJ = $(SRC:%.c=$(OBJDIR)/%.o) $(CPPSRC:%.cpp=$(OBJDIR)/%.o) $(ASRC:%.S=$(OBJDIR)/%.o) 

# Define all listing files.
LST = $(SRC:%.c=$(OBJDIR)/%.lst) $(CPPSRC:%.cpp=$(OBJDIR)/%.lst) $(ASRC:%.S=$(OBJDIR)/%.lst) 

# Compiler flags to generate dependency files.
GENDEPFLAGS = -MMD -MP -MD

# Combine all necessary flags and optional flags.
# Add target processor to flags.
ALL_CFLAGS = -mcpu=$(CPU) -$(CPU_MODE) $(CPU_FLAGS) -I. $(CFLAGS) $(GENDEPFLAGS)
ALL_CPPFLAGS = -mcpu=$(CPU) -$(CPU_MODE) $(CPU_FLAGS) -I. -x c++ $(CPPFLAGS) $(GENDEPFLAGS)
ALL_ASFLAGS = -mcpu=$(CPU) -$(CPU_MODE) $(CPU_FLAGS_ASM) $(ASFLAGS)
# only difference between Linker flags and CFLAGS is CPU_FLAGS_ASM as -mapcs-frame is not needed
ALL_CFLAGS_LINKER = -mcpu=$(CPU) -$(CPU_MODE) $(CPU_FLAGS_ASM)

# Default target.
all: begin gccversion sizebefore build showtarget sizeafter end

# Change the build target to build a HEX file or a library.
build: elf hex bin srec lss sym
#build: lib

elf: $(TARGET).elf
hex: $(TARGET).hex
bin: $(TARGET).bin
srec: $(TARGET).srec
eep: $(TARGET).eep
lss: $(TARGET).lss
sym: $(TARGET).sym
LIBNAME=lib$(TARGET).a
lib: $(LIBNAME)

# Eye candy.
begin:
	@echo
	@echo $(MSG_BEGIN)

end:
	@echo $(MSG_END)
	@echo

# Display size of file.
ELFSIZE = $(SIZE) $(FORMAT_FLAG) $(TARGET).elf

sizebefore:
	@if test -f $(TARGET).elf; then echo; echo $(MSG_SIZE_BEFORE); $(ELFSIZE); \
	2>/dev/null; echo; fi

sizeafter:
	@if test -f $(TARGET).elf; then echo; echo $(MSG_SIZE_AFTER); $(ELFSIZE); \
	2>/dev/null; echo; fi

showtarget:
	@echo
	@echo --------- Target Information ---------
	@echo ARM Model: $(CPU)
	@echo Board:     $(BOARD)
	@echo --------------------------------------
	
# Display compiler version information.
gccversion: 
	@$(CC) --version

program: $(TARGET).hex
	$(LPCISP) -control $(TARGET).hex $(PROGDEV)  230400 4000

# Create final output files (.hex, .eep) from ELF output file.
%.hex: %.elf
	@echo
	@echo $(MSG_FLASH) $@
	$(OBJCOPY) -O $(FORMAT) $< $@

%.bin: %.elf
	@echo
	@echo $(MSG_FLASH) $@
	$(OBJCOPY) -O binary $< $(TARGET).bin

%.srec: %.elf
	@echo
	@echo $(MSG_FLASH) $@
	$(OBJCOPY) -O srec $< $(TARGET).srec

%.eep: %.elf
	@echo
	@echo $(MSG_EEPROM) $@
	-$(OBJCOPY) -j .eeprom --set-section-flags=.eeprom="alloc,load" \
	--change-section-lma .eeprom=0 --no-change-warnings -O $(FORMAT) $< $@ || exit 0

# Create extended listing file from ELF output file.
%.lss: %.elf
	@echo
	@echo $(MSG_EXTENDED_LISTING) $@
	$(OBJDUMP) -h -z -S $< > $@

# Create a symbol table from ELF output file.
%.sym: %.elf
	@echo
	@echo $(MSG_SYMBOL_TABLE) $@
	$(NM) -n $< > $@

# Create library from object files.
.SECONDARY : $(TARGET).a
.PRECIOUS : $(OBJ)
%.a: $(OBJ)
	@echo
	@echo $(MSG_CREATING_LIBRARY) $@
	$(AR) $@ $(OBJ)

# Link: create ELF output file from object files.
.SECONDARY : $(TARGET).elf
.PRECIOUS : $(OBJ)
%.elf: $(OBJ)
	@echo
	@echo $(MSG_LINKING) $@
	$(LD) $(LINKER_SCRIPT) $(ALL_CFLAGS_LINKER) $(LDFLAGS) -o $@ $^

# Compile: create object files from C source files.
$(OBJDIR)/%.o : %.c
	@echo
	@echo $(MSG_COMPILING) $<
	$(CC) -c $(ALL_CFLAGS) $< -o $@ 

# Compile: create object files from C++ source files.
$(OBJDIR)/%.o : %.cpp
	@echo
	@echo $(MSG_COMPILING_CPP) $<
	$(CC) -c $(ALL_CPPFLAGS) $< -o $@ 

# Compile: create assembler files from C source files.
%.s : %.c
	$(AS) -S $(ALL_CFLAGS) $< -o $@

# Compile: create assembler files from C++ source files.
%.s : %.cpp
	$(CC) -S $(ALL_CPPFLAGS) $< -o $@

# Assemble: create object files from assembler source files.
$(OBJDIR)/%.o : %.S
	@echo
	@echo $(MSG_ASSEMBLING) $<

=== host/libubertooth/src/CMakeLists.txt ===
#
# This file is part of Ubertooth.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#
# Based slightly upon the hackrf cmake setup.

# FIXME Set static release version here to avoid pulling from git
set(RELEASE "")

if ( "${RELEASE}" STREQUAL "" )
	# automatic git version when working out of git
	include(GetGitRevisionDescription)
	get_git_head_revision(GIT_REFSPEC RELEASE)
endif()

add_definitions( -DRELEASE="${RELEASE}" )

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/version.c.in"
               "${CMAKE_CURRENT_BINARY_DIR}/version.c"
               @ONLY)

# Targets
set(c_sources ${CMAKE_CURRENT_SOURCE_DIR}/ubertooth.c
              ${CMAKE_CURRENT_SOURCE_DIR}/ubertooth_control.c
			  CACHE INTERNAL "List of C sources")
set(c_headers ${CMAKE_CURRENT_SOURCE_DIR}/ubertooth.h
              ${CMAKE_CURRENT_SOURCE_DIR}/ubertooth_control.h
			  ${CMAKE_CURRENT_SOURCE_DIR}/ubertooth_interface.h
			  CACHE INTERNAL "List of C headers")

# For cygwin just force UNIX OFF and WIN32 ON
if( ${CYGWIN} )
	SET(UNIX OFF)
	SET(WIN32 ON)
endif( ${CYGWIN} )

# FIXME: This may be a hack
# perhaps there should be separate ubertooth and ubertooth-static targets?
if( ${WIN32} )
	# Static library
	add_library(ubertooth STATIC ${c_sources})
	set_target_properties(ubertooth PROPERTIES OUTPUT_NAME "ubertooth_static")
else()
	# Dynamic library
	add_library(ubertooth SHARED ${c_sources})
	set_target_properties(ubertooth PROPERTIES VERSION ${MAJOR_VERSION}.${MINOR_VERSION} SOVERSION 0)
endif()

set_target_properties(ubertooth PROPERTIES CLEAN_DIRECT_OUTPUT 1)

# Include and link to libbtbb and libusb-1.0
find_package(BTBB REQUIRED)
find_package(USB1 REQUIRED)

# Use pcap only if BTBB supports it and user hasn't explicitly disabled it
# If user explicitly enables it but BTBB doesn't support it, raise an error
if( (NOT DEFINED USE_PCAP) OR USE_PCAP )
	if( USE_PCAP AND (NOT HAVE_BTBB_PCAP) )
		message( FATAL_ERROR
			"libbtbb does not support pcap, which is required for USE_PCAP")
	else()
		if(HAVE_BTBB_PCAP)
			add_definitions( -DENABLE_PCAP )
		endif()
	endif()
endif()

include_directories(${LIBUSB_INCLUDE_DIR} ${LIBBTBB_INCLUDE_DIR})
LIST(APPEND LIBUBERTOOTH_LIBS ${LIBUSB_LIBRARIES} ${LIBBTBB_LIBRARIES})

target_link_libraries(ubertooth ${LIBUBERTOOTH_LIBS})

if( ${UNIX} )
   install(TARGETS ubertooth
           LIBRARY DESTINATION lib${LIB_SUFFIX}
           COMPONENT sharedlibs
           )
   install(FILES ${c_headers}
           DESTINATION include
           COMPONENT headers
           )
endif( ${UNIX} )

if( ${WIN32} )
   install(TARGETS ubertooth
           DESTINATION bin
           COMPONENT staticlibs
           )
   install(FILES ${c_headers}
           DESTINATION include
           COMPONENT headers
           )
endif( ${WIN32} )

=== host/ubertooth-tools/src/CMakeLists.txt ===
#
# Copyright 2013 Dominic Spill
#
# This file is part of Ubertooth
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#

# Based heavily upon the hackrf cmake setup.

find_package(BTBB REQUIRED)
find_package(BLUETOOTH)

# Use pcap only if BTBB supports it and user hasn't explicitly disabled it
# If user explicitly enables it but BTBB doesn't support it, raise an error
if( (NOT DEFINED USE_PCAP) OR USE_PCAP )
	if( USE_PCAP AND (NOT HAVE_BTBB_PCAP) )
		message( FATAL_ERROR
			"libbtbb does not support pcap, which is required for USE_PCAP")
	else()
		if(HAVE_BTBB_PCAP)
			add_definitions( -DENABLE_PCAP )
		endif()
	endif()
endif()

if(USE_OWN_GNU_GETOPT)
	include_directories(../getopt)
	add_library(libgetopt_static STATIC ../getopt/getopt.c)
endif(USE_OWN_GNU_GETOPT)

if(NOT libubertooth_SOURCE_DIR)
	find_package(UBERTOOTH REQUIRED)
	include_directories(${LIBUBERTOOTH_INCLUDE_DIR})
	LIST(APPEND TOOLS_LINK_LIBS ${LIBUBERTOOTH_LIBRARIES})
else()
	include_directories(${libubertooth_SOURCE_DIR}/src)
	LIST(APPEND TOOLS_LINK_LIBS ubertooth)
endif()

include_directories(${LIBUSB_INCLUDE_DIR} ${LIBBTBB_INCLUDE_DIR})

LIST(APPEND TOOLS_LINK_LIBS ${LIBUSB_LIBRARIES} ${LIBBTBB_LIBRARIES})

if(USE_OWN_GNU_GETOPT)
	LIST(APPEND TOOLS_LINK_LIBS libgetopt_static)
endif(USE_OWN_GNU_GETOPT)

LIST(APPEND TOOLS ubertooth-rx ubertooth-dump ubertooth-util ubertooth-btle ubertooth-dfu ubertooth-specan ubertooth-ego)

if( USE_BLUEZ AND NOT ${LIBBLUETOOTH_FOUND} )
	message( FATAL_ERROR
		"Cannot find libbluetooth, which is required for USE_BLUEZ")
endif()

if ( ${LIBBLUETOOTH_FOUND} )
	LIST(APPEND TOOLS ubertooth-follow ubertooth-scan)
	include_directories(${LIBBLUETOOTH_INCLUDE_DIR})
	LIST(APPEND TOOLS_LINK_LIBS ${LIBBLUETOOTH_LIBRARIES})
endif()

foreach(tool ${TOOLS})
	add_executable(${tool} ${tool}.c)
	target_link_libraries(${tool} ${TOOLS_LINK_LIBS})
	install(TARGETS ${tool} RUNTIME DESTINATION ${INSTALL_DEFAULT_BINDIR})
endforeach(tool)

# ubertooth-debug is special because of the extra source file
add_executable(ubertooth-debug ubertooth-debug.c cc2400.c arglist.c)
install(TARGETS ubertooth-debug RUNTIME DESTINATION ${INSTALL_DEFAULT_BINDIR})
target_link_libraries(ubertooth-debug ${TOOLS_LINK_LIBS})

=== debian/changelog ===
ubertooth (2015.09.R2-4) unstable; urgency=medium

  * debian/copyright: Updated copyright year for Debian packaging
  * debian/rules:
    - Use UTC for the timestamp to firmware build as well
    - Use --mode= for tar command to make tarball reproducible

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 23 Feb 2016 17:41:54 +0100

ubertooth (2015.09.R2-3) unstable; urgency=medium

  * debian/rules:
    - Fix order in tarball to make it reproducible
    - Make COMPILE_BY and COMPILE_HOST also deterministic when building
      bluetooth_rxtx.dfu

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 23 Feb 2016 00:13:13 +0100

ubertooth (2015.09.R2-2) unstable; urgency=medium

  * Set changelog date to UTC with LC_ALL=C to make man pages reproducible.
  * Add --mtime to tar command to make tar-ball reproducible.
  * Set TIMESTAMP to "", to make firmware reproducible
  * New standards version (3.9.7). No needed updates.
  * Run "cme fix dpkg-control":
    - Changed Vcs-Git to use secure URL.
    - Various other ordering changes for fields in d/control

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 19 Feb 2016 17:52:46 +0100

ubertooth (2015.09.R2-1) unstable; urgency=low

  * Initial release (Closes: #772509)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Wed, 09 Sep 2015 20:21:57 +0200

=== debian/control ===
Source: ubertooth
Maintainer: Ruben Undheim <ruben.undheim@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               libusb-1.0-0-dev,
               libpcap-dev,
               cmake,
               pkg-config,
               libbluetooth-dev,
               libbtbb-dev,
               python-all-dev,
               txt2man,
               gcc-arm-none-eabi,
               libnewlib-arm-none-eabi,
               libstdc++-arm-none-eabi-newlib
Standards-Version: 3.9.7
Vcs-Browser: https://github.com/rubund/debian-ubertooth/tree/master
Vcs-Git: https://github.com/rubund/debian-ubertooth.git
Homepage: http://ubertooth.sourceforge.net/

Package: libubertooth0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Shared library for Bluetooth experimentation
 Project Ubertooth is an open source wireless development platform suitable for
 Bluetooth experimentation. Ubertooth ships with a capable BLE (Bluetooth Smart)
 sniffer and can sniff some data from Basic Rate (BR) Bluetooth Classic
 connections.
 .
 This package provides the shared library needed by Ubertooth.

Package: libubertooth-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libubertooth0 (= ${binary:Version}),
         libusb-1.0-0-dev,
         libpcap-dev,
         libbluetooth-dev,
         libbtbb-dev,
         ${misc:Depends}
Description: Shared library for Bluetooth experimentation - development files
 Project Ubertooth is an open source wireless development platform suitable for
 Bluetooth experimentation. Ubertooth ships with a capable BLE (Bluetooth Smart)
 sniffer and can sniff some data from Basic Rate (BR) Bluetooth Classic
 connections.
 .
 This package provides the development files for using the ubertooth library.

Package: libubertooth0-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: libubertooth0 (= ${binary:Version}),
         ${misc:Depends}
Description: Shared library for Bluetooth experimentation - debugging symbols
 Project Ubertooth is an open source wireless development platform suitable for
 Bluetooth experimentation. Ubertooth ships with a capable BLE (Bluetooth Smart)
 sniffer and can sniff some data from Basic Rate (BR) Bluetooth Classic
 connections.
 .
 This package contains the debugging files used to investigate problems with
 the ubertooth library.

Package: ubertooth-firmware
Architecture: all
Depends: ${misc:Depends}
Recommends: ubertooth
Suggests: ubertooth-firmware-source
Description: Firmware for Ubertooth
 The Ubertooth hardware needs some firmware to run. The firmware is built with
 arm-none-eabi-gcc. This package contains a number of firmware images that
 may be programmed into the Ubertooth hardware using the 'ubertooth-dfu'
 command.
 .
 The firmware images are installed in /usr/share/ubertooth/firmware/

Package: ubertooth-firmware-source
Architecture: all
Depends: ${misc:Depends},
         ubertooth,
         libubertooth-dev
Recommends: gcc-arm-none-eabi,
            libnewlib-arm-none-eabi,
            libstdc++-arm-none-eabi-newlib
Suggests: ubertooth-firmware
Description: Source code for the Ubertooth firmware
 The Ubertooth hardware needs some firmware to run. The firmware is built with
 arm-none-eabi-gcc. This package contains the source code for the firmware that
 is found in the ubertooth-firmware package.
 .
 The firmware source may be found in /usr/src/ubertooth-firmware-source.tar.gz
 after installing this package.

Package: ubertooth
Architecture: any
Depends: libubertooth0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
         python,
         python-numpy,
         python-pyside.qtcore,
         python-pyside.qtgui
Recommends: ubertooth-firmware
Suggests: ubertooth-firmware-source
Description: 2.4 GHz wireless development platform for Bluetooth experimentation
 Project Ubertooth is an open source wireless development platform suitable for
 Bluetooth experimentation. Ubertooth ships with a capable BLE (Bluetooth Smart)
 sniffer and can sniff some data from Basic Rate (BR) Bluetooth Classic
 connections.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

SOURCE_DATE ?= $(shell dpkg-parsechangelog --show-field Date)
SOURCE_DATE_UTC ?= $(shell LC_ALL=C date -u -d "$(SOURCE_DATE)")
CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d "$(SOURCE_DATE)" +"%d %B %Y")

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

UPSTREAM_PACKAGE_VERSION ?= $(shell dpkg-parsechangelog --show-field Version | sed 's/-[^-]*$$//')

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean --sourcedirectory=host
	dh_auto_clean --sourcedirectory=firmware
	$(RM) debian/man/*.1
	$(RM) -r ubertooth-firmware-source
	$(RM) ubertooth-firmware-source.tar.gz
	$(RM) debian/ubertooth.pc

override_dh_auto_configure:
	# Creating ubertooth-firmare-source.tar.gz:
	cp -rf firmware ubertooth-firmware-source
	cd ubertooth-firmware-source ; patch -R -Np2 < ../debian/patches/02_fix_missing_dfu.patch ; \
	  patch -Np1 < ../debian/patches/patch_include_source.patch
	GZIP=-9n tar --mtime='$(SOURCE_DATE_UTC)' --sort=name --owner=root --group=root \
	  --mode=go=rX,u+rw,a-s -czvf ubertooth-firmware-source.tar.gz \
	  ubertooth-firmware-source/
	#
	
	dh_auto_configure --sourcedirectory=host -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
	  -DUBERTOOTH_GROUP=plugdev -DUDEV_RULES_PATH=/lib/udev/rules.d
	dh_auto_configure --sourcedirectory=firmware

override_dh_auto_build:
	dh_auto_build --sourcedirectory=host
	dh_auto_build --sourcedirectory=firmware -- TIMESTAMP="-DTIMESTAMP=''" \
	  COMPILE_BY="-D'COMPILE_BY=\"user\"'" COMPILE_HOST="-D'COMPILE_HOST=\"localhost\"'"
	cat debian/ubertooth.pc.in | sed 's/DEB_HOST_MULTIARCH/$(DEB_HOST_MULTIARCH)/' | \
	  sed 's/UPSTREAM_PACKAGE_VERSION/$(UPSTREAM_PACKAGE_VERSION)/' > debian/ubertooth.pc

override_dh_auto_install:
	chmod a-x firmware/*/*.bin
	dh_auto_install --sourcedirectory=host
	dh_auto_install --sourcedirectory=firmware
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	cp debian/ubertooth.pc debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/

override_dh_strip:
	dh_strip -plibubertooth0 --keep-debug --dbg-package=libubertooth0-dbg
	dh_strip -pubertooth

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

## ubertooth 2017.03.R2

=== host/CMakeLists.txt ===
--- 
+++ 
@@ -21,23 +21,45 @@
 #top level cmake project for ubertooth lib + tools
 
 cmake_minimum_required(VERSION 2.8)
-set(MAJOR_VERSION 0)
-set(MINOR_VERSION 2)
 project(ubertooth_all)
-set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)
+set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules
+	CACHE STRING "CMake module path")
 
-set(INSTALL_DEFAULT_BINDIR "bin" CACHE STRING "Appended to CMAKE_INSTALL_PREFIX")
-
+set(MAJOR_VERSION 1 CACHE INT "libUbertooth major version number")
+set(MINOR_VERSION 0 CACHE INT "libUbertooth minor version number")
 set( VERSION ${MAJOR_VERSION}.${MINOR_VERSION} )
 add_definitions( -DVERSION="${VERSION}" )
 
 # Comment the following out for releases.
-set(CMAKE_C_FLAGS "$ENV{CFLAGS}")
+set(CMAKE_C_FLAGS "$ENV{CFLAGS}" CACHE STRING "C Flags")
+
+# Defaults: BUILD_SHARED=ON, BUILD_STATIC=OFF
+set(BUILD_SHARED_LIB ON CACHE BOOL "Build shared library")
+set(BUILD_STATIC_LIB OFF CACHE BOOL "Build static library")
+set(BUILD_STATIC_BINS OFF CACHE BOOL "Build static library")
+set(ENABLE_PYTHON ON CACHE BOOL "Build python tools")
+
+# Check that we're building at least one library
+if( NOT ${BUILD_SHARED_LIB} AND NOT ${BUILD_STATIC_LIB} )
+	message( FATAL_ERROR "Not building static or shared library - at least one must be built")
+endif( NOT ${BUILD_SHARED_LIB} AND NOT ${BUILD_STATIC_LIB} )
+
+# Build static bins if we're only building the static lib
+if( ${BUILD_STATIC_LIB} AND NOT ${BUILD_SHARED_LIB} )
+	set(BUILD_STATIC_BINS ON)
+	message(STATUS "Building static executables because only building static library")
+endif( ${BUILD_STATIC_LIB} AND NOT ${BUILD_SHARED_LIB} )
+
+# Complain if we're building the shared lib but static bins
+if( ${BUILD_STATIC_BINS} AND NOT ${BUILD_STATIC_LIB} )
+	message(FATAL "Building static executables not possible with shared library")
+endif( ${BUILD_STATIC_BINS} AND NOT ${BUILD_STATIC_LIB} )
 
 add_subdirectory(libubertooth)
 add_subdirectory(ubertooth-tools)
+add_subdirectory(doc)
 add_subdirectory(misc)
-if(NOT DISABLE_PYTHON)
+if(${ENABLE_PYTHON})
 	add_subdirectory(python)
 endif()

=== firmware/bluetooth_rxtx/Makefile ===
--- 
+++ 
@@ -8,6 +8,10 @@
 	bluetooth.c \
 	bluetooth_le.c \
 	ubertooth_usb.c \
+	ubertooth_rssi.c \
+	ubertooth_cs.c \
+	ubertooth_clock.c \
+	ubertooth_dma.c \
 	cc2400_rangetest.c \
 	ego.c \
 	$(LIBS_PATH)/usb_serial.c \

=== firmware/clock_test/Makefile ===
# Hey Emacs, this is a -*- makefile -*-

# Target file name (without extension).
TARGET = clock_test

# List C source files here. (C dependencies are automatically generated.)
SRC = $(TARGET).c \
	$(LIBS_PATH)/LPC17xx_Startup.c \
	$(LIBS_PATH)/LPC17xx_Interrupts.c \
	$(LIBS_PATH)/ubertooth.c

include ../common.mk

=== host/misc/udev/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    SET(SYSTEM_IS_LINUX TRUE)
    SET(UDEV_OPTION_DEFAULT ON)
else()
    SET(SYSTEM_IS_LINUX FALSE)
    SET(UDEV_OPTION_DEFAULT OFF)
endif()

option(INSTALL_UDEV_RULES
    "Install udev rules for the Ubertooth"
    ${UDEV_OPTION_DEFAULT}
)

set(UDEV_RULES_PATH
    "/etc/udev/rules.d"
    CACHE STRING
    "Target directory for udev rule installation. Ensure you have permissions to write to this directory."
)

if(SYSTEM_IS_LINUX)
    if(INSTALL_UDEV_RULES)
        if(NOT DEFINED UDEV_RULES_GROUP)
            foreach(group usb plugdev)
                execute_process(COMMAND "getent" group "${group}"
                                RESULT_VARIABLE _GETENT_RESULT
                                OUTPUT_QUIET
                                ERROR_QUIET)
                if(NOT _GETENT_RESULT)
                    message(STATUS "Setting udev rule group to - ${group}")
                    set(UDEV_RULES_GROUP ${group})
                    break()
                endif(NOT _GETENT_RESULT)
            endforeach(group)
        endif(NOT DEFINED UDEV_RULES_GROUP)
        if(DEFINED UDEV_RULES_GROUP)
            set(UBERTOOTH_GROUP "${UDEV_RULES_GROUP}"
                CACHE STRING "Group to associate Ubertooth devices with in udev rules")
            configure_file(${CMAKE_CURRENT_SOURCE_DIR}/40-ubertooth.rules.in
                        ${CMAKE_CURRENT_BINARY_DIR}/40-ubertooth.rules
                        @ONLY
                        )
            message(STATUS  "Ubertooth udev rules will be installed to '${UDEV_RULES_PATH}' upon running 'make install'")
            install(FILES ${CMAKE_CURRENT_BINARY_DIR}/40-ubertooth.rules
                    DESTINATION ${UDEV_RULES_PATH}
                    COMPONENT "udev_rules")
        else(UDEV_RULES_GROUP)
            message(STATUS "Ubertooth udev rules will not be installed because no suitable group was found")
            message(STATUS "A group can be specified with -DUDEV_RULES_GROUP=<group>")
        endif(DEFINED UDEV_RULES_GROUP)
    else(INSTALL_UDEV_RULES)
        message(STATUS
                "Ubertooth udev rules will not be installed because INSTALL_UDEV_RULES=OFF"
               )
    endif(INSTALL_UDEV_RULES)
else(SYSTEM_IS_LINUX)
    if(INSTALL_UDEV_RULES)
        message(STATUS "udev rules not supported on this platform. Hide this message via -DINSTALL_UDEV_RULES=Off")
    endif(INSTALL_UDEV_RULES)
endif(SYSTEM_IS_LINUX)

=== host/ubertooth-tools/src/CMakeLists.txt ===
--- 
+++ 
@@ -19,23 +19,18 @@
 # Boston, MA 02110-1301, USA.
 #
 
-# Based heavily upon the hackrf cmake setup.
+set(INSTALL_DEFAULT_BINDIR "bin" CACHE STRING
+	"Bin install path, relative to CMAKE_INSTALL_PREFIX")
 
 find_package(BTBB REQUIRED)
 find_package(BLUETOOTH)
 
-# Use pcap only if BTBB supports it and user hasn't explicitly disabled it
-# If user explicitly enables it but BTBB doesn't support it, raise an error
-if( (NOT DEFINED USE_PCAP) OR USE_PCAP )
-	if( USE_PCAP AND (NOT HAVE_BTBB_PCAP) )
-		message( FATAL_ERROR
-			"libbtbb does not support pcap, which is required for USE_PCAP")
-	else()
-		if(HAVE_BTBB_PCAP)
-			add_definitions( -DENABLE_PCAP )
-		endif()
-	endif()
-endif()
+if( ${BUILD_STATIC_BINS} )
+	find_package(USB1 REQUIRED)
+	SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
+	SET(BUILD_SHARED_LIBRARIES OFF)
+	SET(CMAKE_EXE_LINKER_FLAGS "-static")
+endif( ${BUILD_STATIC_BINS} )
 
 if(USE_OWN_GNU_GETOPT)
 	include_directories(../getopt)
@@ -48,7 +43,12 @@
 	LIST(APPEND TOOLS_LINK_LIBS ${LIBUBERTOOTH_LIBRARIES})
 else()
 	include_directories(${libubertooth_SOURCE_DIR}/src)
-	LIST(APPEND TOOLS_LINK_LIBS ubertooth)
+	if( ${BUILD_SHARED_LIB} AND NOT ${BUILD_STATIC_BINS} )
+		LIST(APPEND TOOLS_LINK_LIBS ubertooth)
+	endif( ${BUILD_SHARED_LIB} AND NOT ${BUILD_STATIC_BINS} )
+	if( ${BUILD_STATIC_LIB} OR ${BUILD_STATIC_BINS} )
+		LIST(APPEND TOOLS_LINK_LIBS ubertooth-static)
+	endif( ${BUILD_STATIC_LIB} OR ${BUILD_STATIC_BINS} )
 endif()
 
 include_directories(${LIBUSB_INCLUDE_DIR} ${LIBBTBB_INCLUDE_DIR})
@@ -59,7 +59,7 @@
 	LIST(APPEND TOOLS_LINK_LIBS libgetopt_static)
 endif(USE_OWN_GNU_GETOPT)
 
-LIST(APPEND TOOLS ubertooth-rx ubertooth-dump ubertooth-util ubertooth-btle ubertooth-dfu ubertooth-specan ubertooth-ego)
+LIST(APPEND TOOLS ubertooth-rx ubertooth-tx ubertooth-dump ubertooth-util ubertooth-btle ubertooth-dfu ubertooth-specan ubertooth-ego ubertooth-afh)
 
 if( USE_BLUEZ AND NOT ${LIBBLUETOOTH_FOUND} )
 	message( FATAL_ERROR

=== debian/changelog ===
ubertooth (2017.03.R2-2) unstable; urgency=low

  * debian/control:
    - Add "Multi-Arch: foreign" to ubertooth-firmware
  * debian/tests/buildfirmware:
    - Pipe stderr to stdout for "make" invocation to prevent the CI test
      from failing due to some build warnings.
  * debian/tests/control:
    - Explicitly include all test dependencies

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 16 Jul 2017 18:40:08 +0000

ubertooth (2017.03.R2-1) unstable; urgency=low

  * Upload to unstable
  * debian/control:
    - New standards version 4.0.0 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 13 Jul 2017 23:03:25 +0200

ubertooth (2017.03.R2-1~exp2) experimental; urgency=low

  * debian/control:
    - Updated long description for binary package ubertooth
  * debian/tests/*:
    - Added autopkgtest for building firmware from ubertooth-firmware-source.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 01 Apr 2017 07:07:10 +0000

ubertooth (2017.03.R2-1~exp1) experimental; urgency=medium

  * New upstream version (Closes: #852141)
  * libubertooth0 -> libubertooth1
  * debian/libubertooth1.symbols:
    - Added new symbols and removed some symbols
  * debian/ubertooth.manpages: Use new upstream man pages instead
  * debian/control:
    - New standards version: 3.9.8
    - Removed -dbg package (now handled automatically)
    - Set versioned build-dependency on libbtbb-dev
  * debian/copyright:
    - Updated copyright information
  * debian/man/ubertooth-tx.txt:
    - New dummy man page for ubertooth-tx not yet
      included in package
  * debian/patches/0006-Try-fixing-two-lintians.patch
    - Some of the upstream man pages needed to be patch to not
      cause lintians
  * debian/patches/*: All other patches refreshed
  * debian/rules:
    - No need to explicitly override dh_strip anymore
    - Skip installing ubertooth-tx, since it does not do anything yet.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 14 Mar 2017 20:35:32 +0100

=== debian/control ===
--- 
+++ 
@@ -2,24 +2,25 @@
 Maintainer: Ruben Undheim <ruben.undheim@gmail.com>
 Section: science
 Priority: optional
+Testsuite: autopkgtest
 Build-Depends: debhelper (>= 9),
                libusb-1.0-0-dev,
                libpcap-dev,
                cmake,
                pkg-config,
                libbluetooth-dev,
-               libbtbb-dev,
+               libbtbb-dev (>= 2017.03.R2),
                python-all-dev,
                txt2man,
                gcc-arm-none-eabi,
                libnewlib-arm-none-eabi,
                libstdc++-arm-none-eabi-newlib
-Standards-Version: 3.9.7
+Standards-Version: 4.0.0
 Vcs-Browser: https://github.com/rubund/debian-ubertooth/tree/master
 Vcs-Git: https://github.com/rubund/debian-ubertooth.git
 Homepage: http://ubertooth.sourceforge.net/
 
-Package: libubertooth0
+Package: libubertooth1
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -38,7 +39,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libubertooth0 (= ${binary:Version}),
+Depends: libubertooth1 (= ${binary:Version}),
          libusb-1.0-0-dev,
          libpcap-dev,
          libbluetooth-dev,
@@ -52,24 +53,9 @@
  .
  This package provides the development files for using the ubertooth library.
 
-Package: libubertooth0-dbg
-Architecture: any
-Multi-Arch: same
-Section: debug
-Priority: extra
-Depends: libubertooth0 (= ${binary:Version}),
-         ${misc:Depends}
-Description: Shared library for Bluetooth experimentation - debugging symbols
- Project Ubertooth is an open source wireless development platform suitable for
- Bluetooth experimentation. Ubertooth ships with a capable BLE (Bluetooth Smart)
- sniffer and can sniff some data from Basic Rate (BR) Bluetooth Classic
- connections.
- .
- This package contains the debugging files used to investigate problems with
- the ubertooth library.
-
 Package: ubertooth-firmware
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: ubertooth
 Suggests: ubertooth-firmware-source
@@ -100,7 +86,7 @@
 
 Package: ubertooth
 Architecture: any
-Depends: libubertooth0 (= ${binary:Version}),
+Depends: libubertooth1 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends},
          python,
@@ -111,6 +97,13 @@
 Suggests: ubertooth-firmware-source
 Description: 2.4 GHz wireless development platform for Bluetooth experimentation
  Project Ubertooth is an open source wireless development platform suitable for
- Bluetooth experimentation. Ubertooth ships with a capable BLE (Bluetooth Smart)
- sniffer and can sniff some data from Basic Rate (BR) Bluetooth Classic
+ Bluetooth experimentation. This package contains everything necessary to use
+ the hardware dongle.
+ .
+ Ubertooth is capable of sniffing BLE (Bluetooth Smart) connections and it also
+ has some ability to sniff some data from Basic Rate (BR) Bluetooth Classic
  connections.
+ .
+ In addition to the Bluetooth specific capabilities, there is also a simple
+ spectrum analyzer for the 2.4 GHz band included (ubertooth-specan-ui) which
+ can be used to also observe other things in this frequency band.

=== debian/rules ===
--- 
+++ 
@@ -53,10 +53,8 @@
 	dh_auto_install --sourcedirectory=firmware
 	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
 	cp debian/ubertooth.pc debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
-
-override_dh_strip:
-	dh_strip -plibubertooth0 --keep-debug --dbg-package=libubertooth0-dbg
-	dh_strip -pubertooth
+	rm debian/tmp/usr/bin/ubertooth-tx # The tool does nothing - not fully implemented. Skip installing
+	                                   # TODO: remove line when tool has been implemented
 
 override_dh_installman:
 	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh

=== debian/tests/control ===
Tests: buildfirmware
Depends: ubertooth-firmware-source, gcc-arm-none-eabi, libnewlib-arm-none-eabi, libstdc++-arm-none-eabi-newlib
